VERSION 5.00
Begin VB.Form frmStart 
   BackColor       =   &H00000000&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "ChatterBox Server Startup"
   ClientHeight    =   1560
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   4695
   BeginProperty Font 
      Name            =   "Verdana"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmStart.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   ScaleHeight     =   1560
   ScaleWidth      =   4695
   StartUpPosition =   2  'CenterScreen
   Begin VB.CheckBox chkDefault 
      BackColor       =   &H00000000&
      Caption         =   "Default Server Settings"
      ForeColor       =   &H00FFFFFF&
      Height          =   255
      Left            =   2280
      TabIndex        =   6
      Top             =   510
      Value           =   1  'Checked
      Width           =   2415
   End
   Begin VB.CommandButton cmdStart 
      BackColor       =   &H0000FF00&
      Caption         =   "&Start "
      Height          =   375
      Left            =   3240
      Style           =   1  'Graphical
      TabIndex        =   4
      Top             =   1080
      Width           =   1335
   End
   Begin VB.TextBox txtPort 
      BackColor       =   &H00000000&
      ForeColor       =   &H00FFFFFF&
      Height          =   285
      Left            =   1200
      MaxLength       =   4
      TabIndex        =   3
      Text            =   "1234"
      Top             =   480
      Width           =   855
   End
   Begin VB.TextBox txtNickname 
      BackColor       =   &H00000000&
      ForeColor       =   &H00FFFFFF&
      Height          =   285
      Left            =   1200
      TabIndex        =   2
      Text            =   "Admin (Server)"
      Top             =   120
      Width           =   2535
   End
   Begin VB.Label lblStatus 
      BackColor       =   &H00000000&
      Caption         =   "Server not started."
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FFFFFF&
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   1200
      Width           =   2295
   End
   Begin VB.Line Line1 
      BorderColor     =   &H00FFFFFF&
      Index           =   1
      X1              =   120
      X2              =   4560
      Y1              =   960
      Y2              =   960
   End
   Begin VB.Line Line1 
      BorderColor     =   &H00808080&
      BorderWidth     =   2
      Index           =   0
      X1              =   120
      X2              =   4560
      Y1              =   960
      Y2              =   960
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      BackColor       =   &H00000000&
      Caption         =   "Port:"
      ForeColor       =   &H00FFFFFF&
      Height          =   195
      Index           =   1
      Left            =   120
      TabIndex        =   1
      Top             =   510
      Width           =   420
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      BackColor       =   &H00000000&
      Caption         =   "Nickname:"
      ForeColor       =   &H00FFFFFF&
      Height          =   195
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   150
      Width           =   915
   End
End
Attribute VB_Name = "frmStart"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub chkDefault_Click()
    If chkDefault.value = 0 Then
        txtNickname.Enabled = True
        txtPort.Enabled = True
        txtNickname.Text = ""
        txtPort.Text = ""
        cmdStart.BackColor = vbRed
    ElseIf chkDefault.value = 1 Then
        txtNickname.Enabled = False
        txtPort.Enabled = False
        txtNickname.Text = "Admin (Server)"
        txtPort.Text = "1234"
        cmdStart.BackColor = vbGreen
    End If
End Sub

Private Sub cmdStart_Click()
    'Check input.
    txtNickname.Text = Trim$(Replace$(Replace$(txtNickname.Text, Chr$(2), ""), Chr$(4), ""))
    txtPort.Text = Trim$(txtPort.Text)
    
    If Len(txtNickname.Text) = 0 Then
        MsgBox "Please enter a nickname", vbCritical
        txtNickname.SetFocus
        Exit Sub
    ElseIf Len(txtPort.Text) = 0 Then
        MsgBox "Please enter a port", vbCritical
        txtPort.SetFocus
        Exit Sub
    ElseIf Not IsNumeric(txtPort.Text) Then
        MsgBox "Invalid port! Port must be numeric", vbCritical
        On Error Resume Next 'yea, yea...
        txtPort.SetFocus 'Can raise error.
        'Select all text.
        txtPort.SelStart = 0
        txtPort.SelLength = Len(txtPort.Text)
        Exit Sub
    End If
    
    'Code got this far, input is okay...
    'Close server first.
    ModChat.CloseServer
    'Now open server and hide this form.
    With frmChat
        .sckServer(0).Close
        .sckServer(0).LocalPort = CInt(txtPort.Text)
        .sckServer(0).Listen 'Opens the winsock control.
    End With
    
    ModServer.strMyNickname = txtNickname.Text
    frmChat.Show
    frmChat.lstUsers.Clear
    frmAdmin.lstUsers1.Clear
    frmChat.lstUsers.AddItem strMyNickname
    frmChat.lstUsers.ListIndex = 0
    AddStatusMessage frmChat.rtbChat, RGB(0, 128, 0), "> Server started on local IP (" & frmChat.sckServer(0).LocalIP & ":" & txtPort.Text & ")."
    AddStatusMessage frmChat.rtbChat, RGB(128, 0, 0), ">> Thank you for using ChatterBox Server v1.0"
    AddStatusMessage frmChat.rtbChat, RGB(0, 128, 128), ">Smith Assist -- http://smithassist.dyndns.org"
    frmChat.txtMsg.SetFocus
    Me.Hide
End Sub

Private Sub Form_Activate()
If bolRestart = True Then
        Call cmdStart_Click
        bolRestart = False
    End If
    bolTimeStamp = True
End Sub

Private Sub Form_Load()
    Dim sNextLine As String
    Dim intNext As Integer
    Call chkDefault_Click
    Open App.Path & "\greeting.ini" For Input As #1
    Line Input #1, strMyGreeting
    Close #1

End Sub

Private Sub txtNickname_Change()
    If Len(txtNickname.Text) = 0 Then
        cmdStart.BackColor = vbRed
        Exit Sub
    Else
        If Len(txtNickname.Text) > 0 Then
            If Len(txtPort.Text) > 0 Then cmdStart.BackColor = vbGreen
        ElseIf Len(txtPort.Text) > 0 Then
            If Len(txtNickname.Text) > 0 Then cmdStart.BackColor = vbGreen
        Else
            cmdStart.BackColor = vbRed
            Exit Sub
        End If
    End If
    If Len(txtPort.Text) = 0 Then
        cmdStart.BackColor = vbRed
        Exit Sub
    Else
        If Len(txtNickname.Text) > 0 Then
            If Len(txtPort.Text) > 0 Then cmdStart.BackColor = vbGreen
        ElseIf Len(txtPort.Text) > 0 Then
            If Len(txtNickname.Text) > 0 Then cmdStart.BackColor = vbGreen
        Else
            cmdStart.BackColor = vbRed
            Exit Sub
        End If
    End If
End Sub

Private Sub txtPort_Change()
    Call txtNickname_Change
End Sub

Private Sub txtPort_KeyPress(KeyAscii As Integer)
    'Numbers only.
    If Not IsNumeric(Chr$(KeyAscii)) And Not KeyAscii = 8 Then KeyAscii = 0
    
End Sub
