Attribute VB_Name = "ModServer"
Option Explicit

'My nickname.
Public strMyNickname As String
Public strMyGreeting As String
Public intUserAdmin As Integer
Public strAdminIPSave As String
Public strBanned() As String
Public strMuted() As String
Public bolRestart As Boolean
Public bolTimeStamp As Boolean
Public strSave As String
Global frmPMs() As New frmPrivateMessage
Global strPMsHide() As String

Public Sub Ban_Load()
    Dim intFF As Integer
    intFF = FreeFile
    
    Erase strBanned
    On Error GoTo ErrorHandler
    Open App.Path & "\banned.txt" For Input As #intFF
        If LOF(intFF) > 0 Then strBanned = Split(Input(LOF(intFF), intFF), vbCrLf)
    Close #intFF
    Exit Sub
ErrorHandler:
    Close #intFF
    Exit Sub
End Sub

Public Sub Ignore_AddRemove(ByRef Username As String)
    Dim u As Long, l As Long, s As String
    '1 = on 0 = off
    On Error GoTo ErrorHandler
    s = LCase$(Username)
    u = UBUsers
    For l = 0 To u
        If LCase$(udtUsers(l).strNickname) = s Then
            If udtUsers(l).bolIgnored = False Then
                udtUsers(l).bolIgnored = True
                AddStatusMessage frmChat.rtbChat, RGB(128, 0, 0), udtUsers(l).strNickname & " ignored."
                Exit For
            ElseIf udtUsers(l).bolIgnored = True Then
                udtUsers(l).bolIgnored = False
                AddStatusMessage frmChat.rtbChat, RGB(128, 0, 0), udtUsers(l).strNickname & " un-ignored."
                Exit For
            End If
        End If
    Next l
ErrorHandler:
End Sub

Public Sub Mute_Check(ByRef Username As String)
    On Error GoTo ErrorHandler
    If GlobalMute_IsMuted(Username) = True Then
        frmChat.mnuMute.Caption = "Global Un-Mute"
    ElseIf GlobalMute_IsMuted(Username) = False Then
        frmChat.mnuMute.Caption = "Global Mute"
    End If
ErrorHandler:
End Sub

Public Sub Ignore_Check(ByRef Username As String)
    Dim u As Long, l As Long, s As String
    On Error GoTo ErrorHandler
    s = LCase$(Username)
    u = UBUsers
    For l = 0 To u
        If LCase$(udtUsers(l).strNickname) = s Then
            If udtUsers(l).bolIgnored = False Then
                frmChat.mnuIgnore.Caption = "Ignore"
            ElseIf udtUsers(l).bolIgnored = True Then
                frmChat.mnuIgnore.Caption = "Un-Ignore"
            End If
        End If
    Next l
ErrorHandler:
End Sub

Public Sub Mute_Save(ByRef IPAddress As String, Switch As Integer)
    Dim intFF As Integer, l As Long, u As Long
    Dim sNextLine As String
    intFF = FreeFile
On Error Resume Next
Kill App.Path & "\muted.txt"
On Error GoTo ErrorHandler
   If Switch = 1 Then
         u = Mute_Ubound
         If u > -1 Then
             Open App.Path & "\muted.txt" For Append As #intFF
                 For l = 0 To u
                     If Len(strMuted(l)) > 0 Then
                         If l < u Then
                             Print #intFF, strMuted(l)
                         Else
                             Print #intFF, strMuted(l)
                         End If
                     End If
                 Next l
             Close #intFF
         End If
    ElseIf Switch = 0 Then
        u = Mute_Ubound
        If u > -1 Then
            Open App.Path & "\muted.txt" For Input As #intFF
                Do Until EOF(intFF)
                    Line Input #intFF, sNextLine
                    If Not sNextLine = "" Then
                        If Not sNextLine = IPAddress Then
                            strMuted(l) = sNextLine
                        Else
                            strMuted(l) = vbNullString
                        End If
                    End If
                    l = l + 1
                Loop
            Close #intFF
            Open App.Path & "\muted.txt" For Output As #intFF
                Print #intFF, vbNullString
            Close #intFF
            Open App.Path & "\muted.txt" For Append As #intFF
                 For l = 0 To u
                     If Len(strMuted(l)) > 0 Then
                         If l < u Then
                             If Not IPAddress = strMuted(l) Then Print #intFF, strMuted(l)
                         Else
                             If Not IPAddress = strMuted(l) Then Print #intFF, strMuted(l)
                         End If
                     End If
                 Next l
             Close #intFF
        End If
    End If
ErrorHandler:
    Close #intFF
    Call Mute_Load
    Exit Sub
End Sub

Public Sub Mute_Load()
    Dim intFF As Integer, u As Long, l As Long, r As Long, m As Long
    intFF = FreeFile
    
    Erase strMuted
    On Error GoTo ErrorHandler
    Open App.Path & "\muted.txt" For Input As #intFF
        If LOF(intFF) > 0 Then strMuted = Split(Input(LOF(intFF), intFF), vbCrLf)
    Close #intFF
    Exit Sub
ErrorHandler:
    Close #intFF
    Exit Sub
    u = UBUsers
    m = Mute_Ubound
    If m > -1 Then
        For l = 0 To m
            If Not strMuted(l) = "" Then
                For r = 0 To u
                    If strMuted(l) = udtUsers(r).strNickname Then
                        udtUsers(r).bolMuted = True
                        Exit For
                    End If
                Next r
            End If
        Next l
    End If
        
    
        
End Sub

Public Sub Ban_Save()
    Dim intFF As Integer, l As Long, u As Long
    intFF = FreeFile
    
    On Error Resume Next
    Kill App.Path & "\banned.txt"
    On Error GoTo ErrorHandler
    u = Ban_UBound
    If u > -1 Then
        Open App.Path & "\banned.txt" For Append As #intFF
            For l = 0 To u
                If Len(strBanned(l)) > 0 Then
                    If l < u Then
                        Print #intFF, strBanned(l)
                    Else
                        Print #intFF, strBanned(l)
                    End If
                End If
            Next l
        Close #intFF
    End If
    Exit Sub
ErrorHandler:
    Close #intFF
    Exit Sub
End Sub

Public Sub GlobalMute_Add(ByRef Username As String)
    Dim u As Long
    u = Mute_Ubound + 1
    ReDim Preserve strMuted(0 To u) As String
    strMuted(u) = Username
End Sub

Public Sub Ban_Add(ByRef IPAddress As String)
    Dim u As Long
    u = Ban_UBound + 1
    ReDim Preserve strBanned(0 To u) As String
    strBanned(u) = IPAddress
End Sub

Public Function GlobalMute_IsMuted(ByRef Username As String) As Boolean
    Dim l As Long, u As Long
    u = Mute_Ubound
    If u > -1 Then
        For l = 0 To u
            If strMuted(l) = Username Then
                GlobalMute_IsMuted = True
                Exit For
            End If
        Next l
    End If
End Function

Public Function Ban_IsBanned(ByRef IPAddress As String) As Boolean
    Dim l As Long, u As Long
    u = Ban_UBound
    If u > -1 Then
        For l = 0 To u
            If strBanned(l) = IPAddress Then
                Ban_IsBanned = True
                Exit For
            End If
        Next l
    End If
End Function

Public Function Mute_Ubound() As Long
    On Error GoTo ErrorHandler
    Mute_Ubound = UBound(strMuted)
    Exit Function
ErrorHandler:
    Mute_Ubound = -1
    Exit Function
End Function

Public Function Ban_UBound() As Long
    On Error GoTo ErrorHandler
    Ban_UBound = UBound(strBanned)
    Exit Function
ErrorHandler:
    Ban_UBound = -1
    Exit Function
End Function

Public Function UbIM() As Long
    On Error GoTo ErrorHandler
    UbIM = UBound(frmPMs)
    Exit Function
ErrorHandler:
    UbIM = -1
    Exit Function
End Function

Public Sub Send_PM(Sender As String, Message As String, Recipient As String, SendRecieveForward As Integer)
    'bolSendRecieve 0 = Send, 1 = Recieve
    Dim l As Long, u As Long, s As String
    Dim strPacket As String
    If SendRecieveForward = 0 Then
        'send message
        u = UBUsers
        s = LCase$(Recipient)
        strPacket = "IPM" & Chr$(2) & Sender & Chr$(2) & Message & Chr$(2) & Recipient & Chr$(4)
        For l = 0 To u
            If LCase$(udtUsers(l).strNickname) = s Then
                frmChat.sckServer(l).SendData strPacket
                Exit For
            End If
        Next l
    ElseIf SendRecieveForward = 1 Then
        'recieve message
        u = UbIM
        For l = 0 To u
            If frmPMs(l).Caption = Sender Then
                AddChatMessage frmPMs(l).rtbPM, Sender, Message
                frmPMs(l).lblLastMsg.Caption = "Last message received on " & Date & " at " & Time
                If PMsHide_IsHiding(Sender) = True Then frmPMs(l).Show
                Exit For
            ElseIf frmPMs(l).Caption = "" Then
                frmPMs(l).rtbPM.Text = ""
                frmPMs(l).Caption = Sender
                frmPMs(l).Show
                AddChatMessage frmPMs(l).rtbPM, Sender, Message
                frmPMs(l).lblLastMsg.Caption = "Last message received on " & Date & " at " & Time
                frmPMs(l).rtbPM.SelStart = Len(frmPMs(l).rtbPM.Text)
                AddNewPM
                Exit For
            End If
        Next l
    ElseIf SendRecieveForward = 2 Then
        'forward message because its not mine
        u = UBUsers
        s = LCase$(Recipient)
        For l = 0 To u
            If LCase$(udtUsers(l).strNickname) = s Then
                strPacket = "IPM" & Chr$(2) & Sender & Chr$(2) & Message & Chr$(4)
                frmChat.sckServer(l).SendData strPacket
                Exit For
            End If
        Next l
    End If
End Sub

Public Sub AddNewPM()
    ReDim Preserve frmPMs(UbIM + 1)
End Sub

Public Function PMsHide_IsHiding(ByRef Username As String) As Boolean
    Dim l As Long, u As Long, s As String
    u = PMsHide_UBound
    s = LCase$(Username)
    If u > -1 Then
        For l = 0 To u
            If LCase$(strPMsHide(l)) = s Then
                PMsHide_IsHiding = True
                Exit For
            Else
                PMsHide_IsHiding = False
            End If
        Next l
    End If
End Function

Public Function PMsHide_UBound()
    On Error GoTo ErrorHandler
    PMsHide_UBound = UBound(strPMsHide)
    Exit Function
ErrorHandler:
    PMsHide_UBound = -1
    Exit Function
End Function

Public Sub PMsHide_Add(ByRef Username As String)
    Dim u As Long
    u = PMsHide_UBound + 1
    ReDim Preserve strPMsHide(0 To u) As String
    strPMsHide(u) = Username
End Sub
