Attribute VB_Name = "modDB"
Option Explicit
Public bolStartUpDB As Boolean
Public SQL As String
Public RegInfo As String
Public State As Integer
Public Version As String
Public Connections As Integer
Public Free As Integer
Public User() As TheUsers
Public dbConnectionString As String
Public dbObj As ADODB.Connection

Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Public Declare Function GetFileAttributes Lib "kernel32" Alias "GetFileAttributesA" (ByVal lpFileName As String) As Long
Public Declare Function CreateDirectory Lib "kernel32" Alias "CreateDirectoryA" (ByVal lpPathName As String, lpSecurityAttributes As SECURITY_ATTRIBUTES) As Long
Public Declare Function IsCharAlpha Lib "user32" Alias "IsCharAlphaA" (ByVal cChar As Byte) As Long
Public Type SECURITY_ATTRIBUTES
    nLength As Long
    lpSecurityDescriptor As Long
    bInheritHandle As Long
End Type

Public Type TheUsers
    ID As Integer
    DBUserID As Integer
    Username As String
    RegRollStats As String
End Type



Function ListLoad(filename As String, list As ListBox)
Dim line As String

    Open filename For Input As #1
        While Not EOF(1)
            Input #1, line$
            list.AddItem line$
        Wend
    Close #1
    
End Function

Function ListSave(Name As String, lst As ListBox) As String
Free = FreeFile

Open Name For Output As Free
    For i = 0 To lst.ListCount - 1
        Print #1, lst.list(i)
    Next i
Close #1

End Function

Function FilesLoad(filename As String) As String
On Error Resume Next
Dim line As String
Dim lines As String
    Open filename For Input As #1
        While Not EOF(1)
            Line Input #1, line$
            lines$ = lines$ & line$
        Wend
    Close #1
    
FilesLoad = lines$
End Function


Function FileLoad(filename As String, txt As TextBox)
Dim line As String

    Open filename For Input As #1
        While Not EOF(1)
            Line Input #1, line$
            txt.Text = txt.Text & line$
        Wend
    Close #1
    

End Function



Public Function ReadIni(Name As String, key As String, lp As String, filename As String) As String
    Dim ret As String * 255
    Count = GetPrivateProfileString(Name, key, "", ret, 255, filename)
    ReadIni = Left(ret, Count)
End Function


Function FileSave(Name As String, txt As String)
Free = FreeFile

Open Name For Output As Free
    Print #1, txt
Close #1

End Function

Public Sub WriteIni(Name As String, key As String, lp As String, filename As String)

WritePrivateProfileString Name, key, lp, filename

End Sub

